Numerical : GUIController {
	var <>numerical, <>label, <>fontSize;
	
	*new { arg model, w = 72, h = 20, s = 12;
		if (model.isKindOf(Array), {
			^model.collect({ arg m; 
				super.new(m).width_(w).height_(h).fontSize_(s);
			});
		}, {
			^super.new(model).width_(w).height_(h);
		});
	}
	
	init {
		this.put(\synch, 
			 { arg changer, what;
				 numerical.string = " " ++
				 	model.value
					.round(pow(10, floor(min(0, model.value.abs.log10 - 4))))
					.asString 
					+ model.spec.units.asString;
			}
		);
	}
	draw { arg win;
		if (model.name.size != 0, {
			label = SCStaticText(win, Rect(0, 0, 46, height));
			label.font = Font("Helvetica", 12);
			label.stringColor = Color.black;
			label.align = \right;
			label.string = model.name;
		});		
		numerical = SCNumberBox(win, Rect(10, 0, width, height));
		numerical.font = Font("Helvetica", 12);
		numerical.stringColor = Color.black;
		numerical.resize = 1;
		numerical.value = model.value;
		numerical.action = {arg numerical;  model.value_(numerical.value) };
		model.addDependant(this);
	}
	
	remove {
		super.remove;
//		numerical = nil;
	}
}
