
RadioButtons : GUIController {
	var <>scbuttons, <>curval, <>action, <>states;
	
	*new { arg model, w = 10,h= 10;
			^super.new(model).width_(w).height_(h)
				.states_([[" ", Color.black, Color.grey],[" ", Color.black, Color.blue]]);

	}
		
	init {
		this.put(\synch, { var newval;
			newval = model.value.asInteger;
			if (curval != newval, {
				this.scbuttons.at(curval).value_(0);
				this.scbuttons.at(newval).value_(1); 
			curval = newval;
			});
		});
	}
	
	draw { arg win;
		scbuttons = Array.fill(model.spec.maxval.asInteger, { arg i;
			SCButton(win, Rect(0, 0, width, height)) 
				.states_(states)
				.action_({ model.value_(i); });
				
		});
		scbuttons.at(0).states_([[" ", Color.black, Color.grey] ]);
		curval = model.value.asInteger;
		this.scbuttons.at(curval).value_(1);
		
		model.addDependant(this);
	}
	
	remove {
		super.remove;
		scbuttons = nil;
	}
	
	cmdPeriod { model.input_(0) }
	
}

