Slider : GUIController {
	var <>slider;
	
	*new { arg model, w = 200, h = 20;
		if (model.isKindOf(Array), {
			^model.collect({ arg m; 
				super.new(m).width_(w).height_(h);
			});
		}, {
			^super.new(model).width_(w).height_(h);
		});
	}
	
	init {
		this.put(\synch, 
			 { arg changer, what;
				slider.value_(model.input);
			}
		);
	}
	draw { arg win;
		slider = SCSlider(win, Rect(0, 0, width , height));
		slider.resize = 1;
		slider.action = { 	model.input_(slider.value);  };
		
		model.addDependant(this);
		this.update(model, \synch);
	}
	
	remove {
		super.remove;
	}
}
