PlayStop {
	var <ctl;
	
	*new { | ctl |
		^super.new.ctl_(ctl)
	}
	
	input_ { | val| 
		if (val == 0) { ctl.stop} { ctl.play }
	}
}

PauseResume {
	var <ctl;
	
	*new { | ctl |
		^super.new.ctl_(ctl)
	}
	
	input_ { | val| 
		if (val == 0) { ctl.resume} { ctl.pause }
	}
}

TogglePlay
	{
	var <>ctl, <>oldVal;
	
	*new { | ctl |
		^super.new.ctl_(ctl).oldVal_(0)
	}
	
	input_ { | val|
		if (oldVal ==1) {  ctl.stop; oldVal = 0} { ctl.play; oldVal = 1 }
	}
}

TogglePause
	{
	var <>ctl, <>oldVal;
	
	*new { | ctl |
		^super.new.ctl_(ctl).oldVal_(0)
	}
	
	input_ { | val|
		if (oldVal ==1) {  ctl.resume; oldVal = 0} { ctl.pause; oldVal = 1;}
	}
}
