+ Data {
	plot {
		var dim;
		dim = this.numChans;
		data.collect{|chan| chan.normalize}.flop.flatten.plot(numChannels: dim)
	}
	whitened {|argName|
		var wData;
	
		argName = argName ? (name ++ "_white").asSymbol;

		// analysis already done?
		mins ?? {this.analyse};
		wData = (data - means) / stdDevs;
		
		^Data(argName, chanNames, wData);
	}
	
	vectorsDo { |names, func| 
		this.numFrames.do { |index| func.value(this.vector(index, names), index) }
	}
	
	vectorsCollect { |names, func| 
		^Array.fill(this.numFrames, { |index| func.value(this.vector(index, names), index) });
	}
}
