Event2 : Event { 
	var <orderedKeys; 

	*new { arg n=8, proto, parent, know=true; 
		^super.new(n, proto, parent, know).init
	}
	
	init { orderedKeys = [] }
	
	put { |key, value|
		if (orderedKeys.includes(key).not) { orderedKeys = orderedKeys ++ key };
		super.put(key, value);
	}
	removeAt { |key| 
		orderedKeys.remove(key);
		super.removeAt(key);
	}
	keys { ^orderedKeys }
	origKeys { ^super.keys }
	
	do { |function|
		^orderedKeys.do { |key, i| function.value(this.at(key, i)) }
	}
	keysValuesDo { |function|
		orderedKeys.do { |key, i| function.value(key, this.at(key), i) }
	}
	associationsDo { |function|
		orderedKeys.do { |key, i| function.value( Association.new(key, this.at(key)), i) }
	}
}
/*******
(
e = Event2[
	\otto -> 1, 
	\anna -> 2, 
	\sisi -> 3,
	\zaza -> 4
];
)
e.do(_.postln)

*******/