
Pinterp : FilterPattern {
	var	<>times, <>curves;
	*new { |pattern, times = 1.0, curves = \lin|
		^super.new(pattern).times_(times).curves_(curves)
	}
	embedInStream { |inval|
		var	stream = pattern.asStream,
			timestream = times.asStream,
			curvestream = curves.asStream,
			nextval, time, curve;
		inval = stream.next;
		while { (nextval = stream.next).notNil and: 
				{ (time = timestream.next).notNil } and:
				{ (curve = curvestream.next).notNil }
			}
			{ Env([inval, inval = nextval], [time], [curve]).embedInStream(inval) };
		^inval
	}
}

// pattern should return patterns, each of which should be embedded in the stream
Pembedn : Pn {
	embedInStream { |event|
		var	stream, result;
//"Pembedn-embedInStream".debug;
//pattern.postcs;
		stream = pattern.asStream;
		repeats.value.do({
			(result = stream.next).notNil.if({
				event = result.embedInStream(event);
			}, { "Pembedn got nil, returning".warn; ^event });
		});
		^event
	}
}


// this should be used ONLY for event patterns that will be played on a clock
// streams may terminate prematurely if you use this in other contexts
// this is a workaround until I find a better solution

PnNilSafe : Pn {
	embedInStream { arg event;
		var	saveLogicalTime;
		repeats.value.do {
			saveLogicalTime = thisThread.clock.beats;
			event = pattern.embedInStream(event);
//[thisThread.clock.beats, saveLogicalTime].debug;
			if(thisThread.clock.beats == saveLogicalTime) { ^event }
		};
		^event;
	}
}
