#include "SC_PlugIn.h"
#include "TubeBell.h"
//#include "/Users/paul/stk-4.1.3/include/SKINI.h"
//#include "/Users/paul/stk-4.1.3/include/SKINI.tbl"
#include "Stk.h"

static InterfaceTable *ft;

  struct StkTubeBell : public Unit
{
	TubeBell *tubebell;
};
 
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkTubeBell_next(StkTubeBell *unit, int inNumSamples);
        void StkTubeBell_Ctor(StkTubeBell* unit);
        void StkTubeBell_Dtor(StkTubeBell* unit);
};

//////////////////////////////////////////////////////////////////

void StkTubeBell_Ctor(StkTubeBell* unit)
{
	Stk :: setRawwavePath("/Users/paul/stk-4.1.3/rawwaves");

	unit->tubebell = new TubeBell();
	unit->tubebell->noteOn(IN0(0) ,1);
	SETCALC(StkTubeBell_next);
	StkTubeBell_next(unit, 1);
 
}

void StkTubeBell_next(StkTubeBell *unit, int inNumSamples)
{
	float *out OUT(0);
	
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->tubebell->tick();
        }

}

void StkTubeBell_Dtor(StkTubeBell* unit)
{
	delete unit->tubebell;
}
 
void load(InterfaceTable *inTable)
{
        ft = inTable;
 	    DefineSimpleUnit(StkTubeBell);

}
  