Label {
	var <>label, <name, <>width, <>height, <>font;
	
	*new { arg name, w = 200, h = 20, font;
			^super.new
				.name_(name ? "aLabel")
				.font_(font ? Font("Helvetica", 12))
				.width_(w)
				.height_(h);
	}

	draw { arg win;
		label = SCStaticText(win, Rect(0, 0, width, height));
		label.font = font;
		label.stringColor = Color.black;
		label.align = \right;
		label.string = name;
	}
	
	name_ { arg argName;
			name = argName;
			if (label.notNil, { label.string = name });

	}
	
	remove {}
}
	