
HideView : SCLayoutView {

	*viewClass { ^SCCompositeView }

	init { arg parent,bounds; var w;
		super.init(parent = parent ?? { 
								w = SCWindow.new("",bounds).front;
								if(bounds.notNil,{ bounds = bounds.moveTo(0,0) });
								w
							},
							bounds ?? {parent.asView.bounds.insetAll(2,2,2,2)});
		decorator = HLayout(this.bounds,Point(2,2),Point(4,4));
	}

	visible_ { arg visibleFlag;
		super.visible_(visibleFlag);
		parent.tryPerform(\reflowAndResize);
	}

	reflowAndResize { arg up = true;
		decorator.reset;
		this.children.do({ arg view; view.placeWith(decorator) });
		decorator.bounds = decorator.used;
		this.bounds = decorator.bounds;
		if (up) { parent.tryPerform(\reflowAndResize) };
	}

	placeWith { arg parentDecorator;
		if (this.visible) {
			decorator.bounds_(Rect(parentDecorator.left, parentDecorator.top, 0, 0) );
			decorator.reset;
			this.children.do({ arg view; 
				if ( view.visible) { view.placeWith(decorator) } 
			});
			
			this.bounds = decorator.used;
			parentDecorator.place(this);
		}
	}
	
}

