//redFrik server gui hack
//note that keyboard shortcuts will not work as borderless windows cannot focus

+ Server {
	makeWindow { arg w;
		var active, booter, killer, makeDefault, running, booting, stopped;
		var recorder, scoper;
		var countsViews, ctlr;
		var dumping=false;
		
		var hide, hideInternal= true;	//f0hacked - added vars
		
		if (window.notNil, { ^window.front });
		
		if(w.isNil,{
			w = window = SCWindow(name.asString ++ " server", 
						//f0hacked - changed pos+size+border+colour
						//Rect(10, named.values.indexOf(this) * 120 + 10, 306, 92));
						Rect(1, 1-named.values.indexOf(this)*20+1, RedSkin.screenWidth-2, 19),
						border: false);
						w.view.background_(RedSkin.serverWindow);
			w.view.decorator = FlowLayout(w.view.bounds);
		});
		
		//f0hacked - moved up this block
		active = SCStaticText(w, Rect(0,0, 78, 24));
		active.string = this.name.asString;
		active.align = \center;
		//active.font = Font("Helvetica-Bold", 16);
		active.font = RedSkin.font;					//f0hacked - changed font
		active.background = Color.clear;				//f0hacked - changed name background colour
		if(serverRunning,running,stopped);
		
		hide= SCButton(w, Rect(0, 0, 19, 19));		//f0hacked - added new button
		hide.states= [["x", RedSkin.stringColor, Color.clear],
					["", RedSkin.stringColor, Color.clear]];
		hide.action_({|view|
			if(view.value==1, {
				w.bounds_(Rect(1, 1-named.values.indexOf(this)*20+1, 108, 19));
				w.view.children.do{|x|
					if([active, hide].includes(x).not, {
						x.visible= false;
					});
				};
			}, {
				w.bounds_(Rect(1, 1-named.values.indexOf(this)*20+1, RedSkin.screenWidth-2, 19));
				w.view.children.do{|x| x.visible= true};
			});
		});
		if(this.name==\internal&&hideInternal, {hide.valueAction_(1)});
		
		if(isLocal,{
			booter = SCButton(w, Rect(0,0, 48, 24));
			booter.states = [["Boot", RedSkin.stringColor, Color.clear],
						   ["Quit", RedSkin.stringColor, Color.clear]];
			
			booter.action = { arg view; 
				if(view.value == 1, {
					booting.value;
					this.boot;
				});
				if(view.value == 0,{
					this.quit;
				});
			};
			booter.setProperty(\value,serverRunning.binaryValue);
			
			killer = SCButton(w, Rect(0,0, 24, 24));
			killer.states = [["K", RedSkin.stringColor, Color.clear]];
			
			killer.action = { Server.killAll };	
			killer.enabled = false;		//f0hacked - added this
		});
		
		//makeDefault = SCButton(w, Rect(0,0, 60, 24));
		makeDefault = SCButton(w, Rect(0, 0, 65, 24));	//f0hacked - changed size+colour
		makeDefault.states = [["-> default", RedSkin.stringColor, Color.clear]];
		makeDefault.action = {
			thisProcess.interpreter.s = this;
			Server.default = this;
		};

		//w.view.decorator.nextLine;
		
		recorder = SCButton(w, Rect(0,0, 72, 24));
		recorder.states = [		//f0hacked - changed colour
			["prepare rec", RedSkin.stringColor, Color.clear],
			["record >", RedSkin.stringColor, Color.clear],
			["stop []", RedSkin.stringColor, Color.red(0.7)]
		];
		recorder.action = {
			if (recorder.value == 1) {
				this.prepareForRecord;
			}{
				if (recorder.value == 2) { this.record } { this.stopRecording };
			};
		};
		recorder.enabled = false;
		
		w.view.keyDownAction = { arg ascii, char;
			var startDump, stopDump, stillRunning;
			
			case 
			{char === $n} { this.queryAllNodes }
			{char === $ } { if(serverRunning.not) { this.boot } }
			{char === $s and: {this.inProcess}} { this.scope }
			{char == $d} {
				if(this.isLocal or: { this.inProcess }) {
					stillRunning = {
						SystemClock.sched(0.2, { this.stopAliveThread });
					};
					startDump = { 
						this.dumpOSC(1);
						this.stopAliveThread;
						dumping = true;
						CmdPeriod.add(stillRunning);
					};
					stopDump = {
						this.dumpOSC(0);
						this.startAliveThread;
						dumping = false;
						CmdPeriod.remove(stillRunning);
					};
					if(dumping, stopDump, startDump)
				} {
					"cannot dump a remote server's messages".inform
				}
			
			};
		};
		
		if (isLocal, {
			
			running = {
				active.stringColor_(Color.red(0.7));	//f0hacked - changed colour
				booter.setProperty(\value,1);
				recorder.enabled = true;
				killer.enabled = true;				//f0hacked - added this
			};
			stopped = {
				active.stringColor_(RedSkin.stringColor);
				booter.setProperty(\value,0);
				recorder.setProperty(\value,0);
				recorder.enabled = false;
				killer.enabled = false;				//f0hacked - added this
			};
			booting = {
				active.stringColor_(Color.yellow(0.9));
				//booter.setProperty(\value,0);
			};
			
			w.onClose = {
				//OSCresponder.removeAddr(addr);
				//this.stopAliveThread;
				//this.quit;
				window = nil;
				ctlr.remove;
			};
		},{	
			running = {
				active.background = Color.red(0.7);	//f0hacked - changed colour
				recorder.enabled = true;
			};
			stopped = {
				active.background = RedSkin.stringColor;
				recorder.setProperty(\value,0);
				recorder.enabled = false;

			};
			booting = {
				active.background = Color.yellow(0.9);
			};
			w.onClose = {
				// but do not remove other responders
				this.stopAliveThread;
				ctlr.remove;
			};
		});
		if(serverRunning,running,stopped);
		
		//f0hacked	
		//w.view.decorator.nextLine;

		countsViews = 
		#[
			"Avg CPU :", "Peak CPU :", 
			"UGens :", "Synths :", "Groups :", "SynthDefs :"
		].collect({ arg name, i;
			var label,numView, pctView;
			label = SCStaticText(w, Rect(0,0, 80, 14));
			label.stringColor_(RedSkin.stringColor);	//f0hacked - changed colour
			label.string = name;
			label.align = \right;
		
			if (i < 2, { 
				numView = SCStaticText(w, Rect(0,0, 38, 14));
				//f0hacked - added this line
				numView.stringColor_(RedSkin.stringColor);
				numView.string = "?";
				numView.align = \left;
			
				pctView = SCStaticText(w, Rect(0,0, 12, 14));
				//f0hacked - added this line
				pctView.stringColor_(RedSkin.stringColor);
				pctView.string = "%";
				pctView.align = \left;
			},{
				numView = SCStaticText(w, Rect(0,0, 50, 14));
				//f0hacked - added this line
				numView.stringColor_(RedSkin.stringColor);
				numView.string = "?";
				numView.align = \left;
			});
			
			numView
		});
		
		w.front;

		ctlr = SimpleController(this)
			.put(\serverRunning, {	if(serverRunning,running,stopped) })
			.put(\counts,{
				countsViews.at(0).string = avgCPU.round(0.1);
				countsViews.at(1).string = peakCPU.round(0.1);
				countsViews.at(2).string = numUGens;
				countsViews.at(3).string = numSynths;
				countsViews.at(4).string = numGroups;
				countsViews.at(5).string = numSynthDefs;
			})
			.put(\cmdPeriod,{
				recorder.setProperty(\value,0);
			});	
		this.startAliveThread;
		
		//f0hacked - added this
		w.view.children.do{|view|
			view.bounds_(Rect(view.bounds.left, view.bounds.top, view.bounds.width, 14));
			if(view.respondsTo(\font)) {view.font_(RedSkin.font)}
		};
	}
}
