SpeakerAdjust { 
	var <server, <specs, <vol, <synth, <group; 
	*ar { |ins, specs, vol=1|
		
		^specs.collect { |spec, i|
			var out, amp, dt, eqSpecs; 

			out = ins[i];
			#amp, dt ... eqSpecs = spec; 

			out = if (amp.notNil, { out * (amp * vol) }, { out * vol });

			if (dt ? 0 > 0, { out = DelayN.ar(out, dt, dt) });
		
			eqSpecs.do { |spec|
				var freq, db, rq; 
				#freq, db, rq = spec;
				out = MidEQ.ar(out, freq, rq, db);
			};
			out;
		};	
	}
	*new { |server, specs, vol=1| 
		server = server ? Server.default;		
		^super.newCopyArgs(server, specs, vol)
	}
	
	numChans { ^specs.size }
	
	play { 	// hack: should be one bundle with 
			// make group, send synthdef, s_new with vol argument. 
//		server.makeBundle(server.latency, {
			this.stop; 
			group = Group(server, \t);
			
			synth = { |vol=1|
				ReplaceOut.ar(0, this.class.ar(In.ar(0, this.numChans), specs, vol.lag(0.05))); 
			}.play(group, 0, addAction: \t); 
			
		fork { 0.1.wait;	this.vol_(vol); };
//		})
	}
	stop { 
		synth.free; synth = nil; 
		group.free; group = nil;
	}
	vol_ { |in| 
		vol = in.clip(0, 5); 
		try { synth.set(\vol, vol) };
	}
}