SimpleButton : GUIController {
	var <>scbutton, <>states, <>action;
	
	*new { arg func, w = 40,h= 20;
		var defaultState;
		defaultState = [ ["Start", Color.white, Color(0.2,0.2,0.2)] ];
		func = func ? {};
		if (func.isKindOf(Array), {
			^func.collect({ arg function;
				super.new
				.width_(w).height_(h)
				.states_(defaultState)
				.action_(function);
			});
		}, {
			^super.new
				.width_(w).height_(h)
				.states_(defaultState)
				.action_(func)

		});
	}
	
	draw { arg win;
		scbutton = SCButton(win, Rect(0, 0, width, height))
			.states_(states)
			.action_(action)		
		;
	}
	
	input_{ action.value }	
	
	name_ { arg name;
		states = [[name, Color.white,Color(0.2,0.2,0.2)]];
		width = name.size * GUIController.letterWidth;
	}
}

