
PlayPauseStopButton : GUIController {

	var <>playButton, <>stopButton, <>states, <>action;
	
	*new { arg model, w = 20,h= 20;

			^super.new(model).width_(w).height_(h)
				.states_(
				[ 
					[" >", Color.green,Color(0.2,0.2,0.2,1)],
					[" ||", Color.yellow,Color(0.2,0.2,0.2,1)], 
					[" >", Color.yellow(0.5),Color(0.2,0.2,0.2,1)],
					[" >", Color.green,Color(0.2,0.2,0.2,1)]
				]);
	}
	
	init {
		this.put(\synch, {playButton.value_(model.value) });
	}
	
	name_ { arg name;
		name = name.asString;
		states = [
			[name, Color.green,Color(0.2,0.2,0.2,1)],
			[name, Color.yellow,Color(0.2,0.2,0.2,1)],
			[name, Color.new255(100, 200, 100),Color(0.2,0.2,0.2,1)], 
			[name, Color.green,Color(0.2,0.2,0.2,1)]]
		;
		width = name.size * GUIController.letterWidth;
	}
	draw { arg win;
		playButton = SCButton(win, Rect(0, 0, width, height))
						.states_(states)
						.action_({ arg view; 
							if (view.value ==3, { view.value =1});
							model.value_(view.value) 
						});		
						stopButton = SCButton(win, Rect(0, 0, 20, height))
						.states_( [ [" []", Color.red,Color(0.2,0.2,0.2,1)] ])
						.action_({ arg view; model.value_(0) });		model.addDependant(this);
	}
	
	remove {
		super.remove;
		playButton = nil;
		stopButton = nil;
	}
	
	cmdPeriod { model.input_(0) }
	
}

