
VLayout : FlowLayout {

	init {
		gap = gap ? Point(2,2);
		margin = margin ? Point(2,2);
		this.reset;
	}
	
	used { 
		^Rect(bounds.left,bounds.top,
					 maxRight + margin.x + margin.x - bounds.left,
					maxHeight + margin.y + margin.y - bounds.top)
	}

	place { arg view;
		var height, width,vbounds;
		vbounds = view.bounds;
		width = vbounds.width;
		height = vbounds.height;
		
		view.bounds = Rect(left, top, width, height);

		maxRight = max(maxRight,left + width + gap.x);	
		maxHeight = max(maxHeight, top + height + gap.y);
		
		top = top + height + gap.y;

	}
	
	nextLine {
		left = left + maxRight + gap.x;
		top = bounds.top + margin.y;
		maxRight = 0;
	}

}

HLayout : VLayout {

	place { arg view;
		var height, width,vbounds;
		vbounds = view.bounds;
		width = vbounds.width;
		height = vbounds.height;
		
		view.bounds = Rect(left, top, width, height);

		maxRight = max(maxRight,left + width + gap.x);	
		maxHeight = max(maxHeight, top + height + gap.y);

		left = left + width + gap.x;

	}
	
	nextLine {
		left = bounds.left + margin.x;
		top = top + maxHeight + gap.y;
		maxHeight = 0;
	}

}
