MIDIFaders {
	var <>cvs, <responder;
		*new { arg lo= 0, count= 16;
		^super.new.init(lo, count);
	}
	init {|lo, count|
		cvs = Array.fill(count);
		responder = CCResponder({ | src, chan, ccNum, val|
			var index, cv; 
			index = ccNum - lo;
			cv = cvs[index];
			if (cv.notNil) { cv.input_(val/127) }
		}, num: (lo..lo+count))
	}
	
	connectTo { arg controls, offset = 0;
		controls.do {|cv, i| cvs[i + offset] = cv };
	}

	stop { CCResponder.remove(responder) }
	pause { CCResponder.remove(responder) }
	play { CCResponder.add(responder) }
	resume { CCResponder.add(responder) }
}

MIDIButtons : MIDIFaders {

	var <>cvs, <responder;
		*new { arg lo= 0, count= 16;
		^super.new(lo, count);
	}
	init {|lo, count|
		cvs = Array.fill(count);
		responder = NoteOnResponder({ | src, chan, keyNum, val|
			var index, cv; 
			index = keyNum - lo;
			defer { [keyNum, val].postln };
			cv = cvs[index];
			if (cv.notNil) { cv.input_(val/127) };
		}, num: (lo..lo+count))
	}
	
	connectTo { arg controls, offset = 0;
		controls.do {|cv, i| cvs[i + offset] = cv };
	}

	stop { NoteOnResponder.remove(responder) }
	pause { NoteOnResponder.remove(responder) }
	play { NoteOnResponder.add(responder) }
	resume { NoteOnResponder.add(responder) }


//	*new {
//		^super.new.init
//	}
//	
//	init { 
//		this.clear;
//		MIDIIn.noteOn = { arg src, chan, num, val; this.perform(src, chan, num, val) }; 
//	}
//	clear { 	responders = Array.fill(128, nil); }
//
//	perform { arg src, chan, num, val;
//		var controller;
//		if ((controller = responders.at(num)).notNil, {controller.input_(val/127)})
//	}
//	
//	 
//	connectTo { arg keys, offset;
//		keys.do({ arg k, i; responders.put(i + offset, k) })
//	}
}