	// for correct behavior of AdhocClass
+ Function {
	isFunction { ^true }
}

+ Object {
	isFunction { ^false }
}

	// in adhocclass, parent should contain all functions; all data should go in main dict
	// some data maybe should go in parent: provide a collection of keys
+ IdentityDictionary {
	moveFunctionsToParent { |keysToMove|
		var	movedKeys;	// because you shouldn't delete things from a collection under iteration
//this.debug('prior to adding parent');
//this.dump;
//parent.dump;
//parent !? { parent.keys.debug };
//this.dumpBackTrace;
		movedKeys = IdentitySet.new;
		parent.isNil.if({ parent = this.class.new });
//this.debug('after adding parent');
//parent.dump;
//parent.keys.debug;
			// kvDo iterates only over main dict, not parent
		this.keysValuesDo({ |key, val|
			(val.isFunction or: { keysToMove.notNil and: { keysToMove.includes(key) } }).if({
				movedKeys.add(key);
				parent.put(key, val);
//[key, val].debug('moved object to parent');
//parent.dump;
			});
		});
		movedKeys.do({ |key|
			this.removeAt(key);
		});
	}
}
